% Program demo_7_1
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Decimatin-by-2 with linear-phase half-band FIR filter
% Efficient polyphase configuration with memory-saving structure
 
clear all, close all
h = firhalfband(22,0.4); % FIR filter design
 
% Generation of the input signal
F = [0,0.05,0.45,1]; A = [0,1,0.1,0.05];
x1 = fir2(256,F,A); x2 = sin(2*pi*(0:256)*0.4)/150;
x = x1 + x2;
[X,f] = freqz(x,1,512,2);  % Spectrum of the original signal
figure (1)
subplot(2,1,1)
plot(f,abs(X(1:512))), xlabel('Normalized frequency \omega/\pi'),ylabel('|X(e^{j\omega})|')
axis([0,1,0,1.1])
 
% Polyphase decomposition
e0 = h(1:2:(length(h)-1)/2);
 
% Setting the initial states 
xk = zeros(size(1:(length(h)+1)/2));
 
% Decimation
rot = 0; % Initial swithch position
y = [];
for n=1:length(x)
xn = x(n);
   
if rot==0 ss=1;
    pro = xn*e0;
    xk = [pro+xk(1:length(xk)/2),fliplr(pro) + xk((length(xk)/2+1):length(xk))];
    yn = xk(length(xk));
    y = [yn,y];
    xk = [0,xk(1:length(xk)-1)];
else
end
if rot==1 ss=0;
    xk(length(xk)/2+1) = 0.5*xn + xk(length(xk)/2+1);
else
end
rot=ss;
end
 
Y = freqz(y,1,512,2); % Spectrum of the decimated signal
subplot(2,1,2)
plot(f,abs(Y(1:512))), xlabel('Normalized frequency \omega/\pi'),ylabel('|Y(e^{j\omega})|')
axis([0,1,0,0.6])
