% Example7_2
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% FIR halfband filter, equiripple design
clear all, close all
as = 40;                               % Specifying the minimal stopband attenuation
delta = 10^(-as/20);                   % Computation of the peak ripple
fs = 0.60;                             % Specifying the stopband edge frequency
fp = 1-fs;                             % Computation of the passband edge frequency
h = firhalfband('minorder',fp,delta);  % Computation of filter coefficients
figure (1)
subplot(2,1,1)
stem(0:length(h)-1,h)
xlabel('n'), ylabel('h[n]')
axis([0,22,-0.2,0.6])
[H,f] = freqz(h,1,512,2);
subplot(2,1,2)
plot(f,20*log10(abs(H))),grid
xlabel('\omega/\pi'), ylabel('Gain [dB]')
axis([0,1,-60,5])