% example_7_5
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Elliptic halfband filter design
clear all, close all
as = 45
ap = 10*log10(1+1/(10^(as/10)-1))
fs = 0.57
fp = 1-fs
[N,fp] = ellipord(fp,fs,ap,as)
[b,a,z,p,k] = halfbandiir(7,0.43);
[H,f]=freqz(b,a,1024,2);
figure (1)
plot(f,20*log10(abs(H)))
hold on
fspec=[0.57,0.57,1];
aspec=[2,-45,-45];
plot(fspec,aspec,'--'), xlabel('\omega/\pi'), ylabel('Gain, dB')
axis([0,1,-80,2])
figure (2)
zplane(z,p)
